searchData={"content_type":"text/plain","items":[{"doc":"Parse transform helper library The main function is transform/3 , which let's you easily traverse an ast() , optionally modify it, and carry a state. There are a few helper   functions that provides easy access to commonly needed information. For example the current set of bindings and the MFA for every function call . Finally, when you're done transforming return/1 the result in the format expected by erl_lint (or else you crash the compiler).","ref":"merlin.html","title":"merlin","type":"module"},{"doc":"Returns the result from transform/3 , or just the final forms, to an erl_lint compatible format. This reverts the forms, while respecting any errors and/or warnings.","ref":"merlin.html#return/1","title":"merlin.return/1","type":"function"},{"doc":"Returns the given node or nodes in erl_parse format. Copied from parse_trans:revert_form/1 and slightly modified. The original also handles a bug in R16B03, but that is ancient history now.","ref":"merlin.html#revert/1","title":"merlin.revert/1","type":"function"},{"doc":"Transforms the given Forms using the given Transformer with the given State . This is done thorugh a depth-first traversal of the given Forms . First enter ing each tree node (top-down) Then, when you encounter a leaf node, you both &quot;enter&quot; and &quot;exit&quot; the node Finally exit ing each tree node (bottom-up) For example, if you just want to change a call to a specific function, you would just use the top-down enter phase. parse_transform ( Forms , _ Options ) -&gt; transform ( Forms , fun ( enter , Form , _ State ) -&gt; case erl_syntax : type ( Form ) of %% Application is the name of a function call application -&gt; Operator erl_syntax : application_operator ( Form ) , case erl_syntax : type ( Operator ) =:= atom andalso erl_syntax : atom_value ( Operator ) =:= foo of true -&gt; %% Change `foo(...)&#39; to `my_module:foo(...)&#39; %% using `merl&#39; or `merlin_quote_transform&#39; { return , ? Q ( &quot;my_module:foo(123)&quot; ) } ; false -&gt; continue end ; _ -&gt; continue end ; ( _ , _ , _ ) -&gt; continue end , state ) . Sometimes it is easier, or necessary, to use a bottom-up approach. You can use exit for that. Sometimes you need both, and here is where merlin really shines, as you can just pattern match of enter and exit in the same function. The latter shows up when you want to do some analysis on the way down, and then use that information on the way up. For a real world example see merlin_quote_transform . That one is also pretty handy for writing transformers . See also: transformer/3.","ref":"merlin.html#transform/3","title":"merlin.transform/3","type":"function"},{"doc":"Represents the action to take after calling the transformer() callback. continue means to continue traversing the ast() . delete means to delete the current node from the ast() . return means to stop traversing the ast() and return the current node. exceptions means to stop traversing the ast() and return the given exceptions.","ref":"merlin.html#t:action/0","title":"merlin.action/0","type":"type"},{"doc":"Represents a syntax tree node. May be a tree or a leaf.","ref":"merlin.html#t:ast/0","title":"merlin.ast/0","type":"type"},{"doc":"Copied from erl_syntax","ref":"merlin.html#t:erl_parse/0","title":"merlin.erl_parse/0","type":"type"},{"doc":"A bit dirty to know about the internal structure like this, but erl_syntax:syntaxTree() also includes the vanilla AST and dialyser doesn't always approve of that.","ref":"merlin.html#t:erl_syntax_ast/0","title":"merlin.erl_syntax_ast/0","type":"type"},{"doc":"Represents a compile time error. Must match erl_lint:error_info() .","ref":"merlin.html#t:error_marker/0","title":"merlin.error_marker/0","type":"type"},{"doc":null,"ref":"merlin.html#t:exceptions_grouped_by_file/0","title":"merlin.exceptions_grouped_by_file/0","type":"type"},{"doc":null,"ref":"merlin.html#t:marker_with_file/0","title":"merlin.marker_with_file/0","type":"type"},{"doc":null,"ref":"merlin.html#t:node_or_nodes/0","title":"merlin.node_or_nodes/0","type":"type"},{"doc":null,"ref":"merlin.html#t:parse_transform_return/0","title":"merlin.parse_transform_return/0","type":"type"},{"doc":"Represents the return value from a parse transform. Defined here because there's no parse_transform behaviour.","ref":"merlin.html#t:parse_transform_return/1","title":"merlin.parse_transform_return/1","type":"type"},{"doc":"Represents the direction of the depth-first traversal through the ast() .","ref":"merlin.html#t:phase/0","title":"merlin.phase/0","type":"type"},{"doc":null,"ref":"merlin.html#t:transformer/0","title":"merlin.transformer/0","type":"type"},{"doc":"Represents the callback used by transform/3 .","ref":"merlin.html#t:transformer/1","title":"merlin.transformer/1","type":"type"},{"doc":"Represents the return value from the transformer() callback. The first element is the action() , the second the new or modified node or nodes, and the third the new state. Returning an atom is a shorthand for reusing the current node and state. Returning a two-tuple is a shorthand for reusing the current state. You may also return {error, Reason} | {warning, Reason} to generate a compile time warning. These will be propagated to erl_lint . To generate multiple warnings, return {exceptions, ListOfErrorsAndWarnings} .","ref":"merlin.html#t:transformer_return/1","title":"merlin.transformer_return/1","type":"type"},{"doc":"Represents a compile time warning. Must match erl_lint:error_info() .","ref":"merlin.html#t:warning_marker/0","title":"merlin.warning_marker/0","type":"type"},{"doc":"This module allows for a unified handling of vanilla annotations and user annotations . It maintains the representation of the given syntax node as much as possible, This means that if you given it a vanilla syntax node and set/3 an erl_anno annotation, it will return a vanilla syntax node with the given annotation. However if you either give it an erl_syntax node or set a erl_syntax user annotation, it will return an erl_syntax node.","ref":"merlin_annotations.html","title":"merlin_annotations","type":"module"},{"doc":"Returns the given syntax node without the given annotation. You are not allowed to delete line or location .","ref":"merlin_annotations.html#delete/2","title":"merlin_annotations.delete/2","type":"function"},{"doc":"Returns all annotations for the given syntax node. This merges erl_anno annotations with erl_syntax user annotations. Notably, it always includes both line and location .","ref":"merlin_annotations.html#get/1","title":"merlin_annotations.get/1","type":"function"},{"doc":"Get the value of the given annotation from the given syntax node.","ref":"merlin_annotations.html#get/2","title":"merlin_annotations.get/2","type":"function"},{"doc":"Get the value of the given annotation from the given syntax node. If the annotation is not present, return the given default value. See also: get/2 .","ref":"merlin_annotations.html#get/3","title":"merlin_annotations.get/3","type":"function"},{"doc":"Returns the annotation for the given syntax node. This is just a wrapper around erl_syntax:get_pos/1 , added for completeness.","ref":"merlin_annotations.html#get_anno/1","title":"merlin_annotations.get_anno/1","type":"function"},{"doc":"Returns true if the given syntax node has the given annotation, false otherwise.","ref":"merlin_annotations.html#has/2","title":"merlin_annotations.has/2","type":"function"},{"doc":"Returns the given syntax node with its existing annotations merged with the given ones.","ref":"merlin_annotations.html#merge/2","title":"merlin_annotations.merge/2","type":"function"},{"doc":"Set the given annotation to the given value on the given syntax node. See also: erl_anno , erl_syntax:set_ann/2 , erl_syntax:set_pos/2 .","ref":"merlin_annotations.html#set/3","title":"merlin_annotations.set/3","type":"function"},{"doc":"Returns the given node with the given annotation . Similar to erl_syntax:set_pos/2 , but preserves the representation of the given syntax node.","ref":"merlin_annotations.html#set_anno/2","title":"merlin_annotations.set_anno/2","type":"function"},{"doc":"Reprensent a single builtin annotation property .","ref":"merlin_annotations.html#t:erl_annotation/0","title":"merlin_annotations.erl_annotation/0","type":"type"},{"doc":"The different types of builtin annotations .","ref":"merlin_annotations.html#t:erl_annotation_key/0","title":"merlin_annotations.erl_annotation_key/0","type":"type"},{"doc":"Represents a list of annotations . This is also the internal format of erl_anno if some other annotation than erl_anno:line() and/or erl_anno:line() has been set.","ref":"merlin_annotations.html#t:erl_annotations/0","title":"merlin_annotations.erl_annotations/0","type":"type"},{"doc":"Helpers for working with attribute forms.","ref":"merlin_attributes.html","title":"merlin_attributes","type":"module"},{"doc":"Return the arguments for the first attribute form with the given name, or {error, notfound} if no such attribute is found. The user annotations are copied over from the attribute node. This is is useful to get the merlin_module:analysis() for a module. AnnotatedForms = merlin_module : annotate ( Forms ) , { ok , ModuleArguments } = merlin_attributes : find ( Forms , module ) , #{ module := _ } = merlin_annotations : get ( ModuleArguments , analysis ) .","ref":"merlin_attributes.html#find/2","title":"merlin_attributes.find/2","type":"function"},{"doc":"Returns true if the given Form is an attribute with the given name, false otherwise.","ref":"merlin_attributes.html#is_attribute/2","title":"merlin_attributes.is_attribute/2","type":"function"},{"doc":"Return the name of an attribute form.","ref":"merlin_attributes.html#name/1","title":"merlin_attributes.name/1","type":"function"},{"doc":"Represents an attribute form. That is, the AST for -some_attribute(...). .","ref":"merlin_attributes.html#t:attribute/0","title":"merlin_attributes.attribute/0","type":"type"},{"doc":"Module for manipulating bindings, more commonly known as variables.","ref":"merlin_bindings.html","title":"merlin_bindings","type":"module"},{"doc":"Returns the given node annotated with detailed information about its bindings. Fetches the starting ( env ) bindings from the node itself, defaulting to an empty set if none are found. This is in contrast to erl_syntax_lib:annotate_bindings/1 that crashes if no such bindings can be found. See also: annotate/1 , annotate/2 .","ref":"merlin_bindings.html#annotate/1","title":"merlin_bindings.annotate/1","type":"function"},{"doc":"Returns the given node annotated with detailed information about its bindings using the given bindings as a starting point. See also: erl_syntax_lib:annotate_bindings/2 .","ref":"merlin_bindings.html#annotate/2","title":"merlin_bindings.annotate/2","type":"function"},{"doc":"Returns the state() for given binding in the given node. Prefers bound over env over free over unbound . The latter means that the given binding does not occur in the given node, unlike free which means that the binding will occur later. The given node, or one of its ancestors, must have been annotated with its bindings.","ref":"merlin_bindings.html#get/2","title":"merlin_bindings.get/2","type":"function"},{"doc":"Returns the bindings for the given node in the given state. The given node, or one of its ancestors, must have been annotated with its bindings.","ref":"merlin_bindings.html#get_by_state/2","title":"merlin_bindings.get_by_state/2","type":"function"},{"doc":"Returns true if the given node has been annotated with its bindings.","ref":"merlin_bindings.html#has/1","title":"merlin_bindings.has/1","type":"function"},{"doc":"Returns true if the given node has a binding with the given name.","ref":"merlin_bindings.html#has/2","title":"merlin_bindings.has/2","type":"function"},{"doc":"Returns true if the given node has a binding with the given name in the given state.","ref":"merlin_bindings.html#has/3","title":"merlin_bindings.has/3","type":"function"},{"doc":"Returns a new variable binding guaranteed to be unique with respect to the current set of bindings in the given node. The variable will have its attributes copied from the given node. This means both user annotations, position information, and comments are taken from the given node. In practice it means that stacktraces will point to a more correct location rather then the top of the file. The given node's bindings will be updated to reflect the new variable.","ref":"merlin_bindings.html#new/1","title":"merlin_bindings.new/1","type":"function"},{"doc":"Returns new variable(s) binding according to the given options. The options may specify a format string, which is used to generate the variable name. The format string must contain a single ~tp which is used to ensure uniqueness. You may also specify a total option, which is used to generate multiple variables. Both the format string and the total option can be passed directly as a short hand. See also: new/1 .","ref":"merlin_bindings.html#new/2","title":"merlin_bindings.new/2","type":"function"},{"doc":"Represents the current set of bindings for a node.","ref":"merlin_bindings.html#t:binding_mapping/0","title":"merlin_bindings.binding_mapping/0","type":"type"},{"doc":"Represents a set of bindings. Each binding is its name as an atom.","ref":"merlin_bindings.html#t:bindings/0","title":"merlin_bindings.bindings/0","type":"type"},{"doc":"Represents the state a binding can be in. env Bindings from the surrounding scope, i.e. a fun 's closure. bound Bindings with value. free Bindings without a value. It's a compile time error to try to access them.","ref":"merlin_bindings.html#t:state/0","title":"merlin_bindings.state/0","type":"type"},{"doc":"Represents a variable binding.","ref":"merlin_bindings.html#t:variable/0","title":"merlin_bindings.variable/0","type":"type"},{"doc":"Helpers for working with errors.","ref":"merlin_error.html","title":"merlin_error","type":"module"},{"doc":"Callback for formatting error messages from this module See also: erl_parse:format_error/1 .","ref":"merlin_error.html#format_error/1","title":"merlin_error.format_error/1","type":"function"},{"doc":"Callback for formatting error messages for merlin's modules. See EEP 54","ref":"merlin_error.html#format_error/2","title":"merlin_error.format_error/2","type":"function"},{"doc":"Returns a error info with the given reason and location taken from the second argument. If it is a stacktrace, the latter is taken from the first frame. Otherwise it is assumed to be a syntax node and its location is used.","ref":"merlin_error.html#into_error_marker/2","title":"merlin_error.into_error_marker/2","type":"function"},{"doc":"Helpers for working with erl_syntax:syntaxTree() . Similar to erl_syntax_lib , but with a different set of helpers, and a preference for returning maps over proplists.","ref":"merlin_lib.html","title":"merlin_lib","type":"module"},{"doc":"Returns the first Node that satisfies the given function, or {error, notfound} if no such Node is found. The search is performed recursively.","ref":"merlin_lib.html#deep_find_by/2","title":"merlin_lib.deep_find_by/2","type":"function"},{"doc":"Return the first Node that satisfies the given function, or {error, notfound} if no such form is found. The search is performed shallowly. See also: deep_find_by/2 .","ref":"merlin_lib.html#find_by/2","title":"merlin_lib.find_by/2","type":"function"},{"doc":"Returns a flat list of nodes from the given form list or list of nodes.","ref":"merlin_lib.html#flatten/1","title":"merlin_lib.flatten/1","type":"function"},{"doc":"Returns true if the given syntax node is a erl_syntax node, false otherwise.","ref":"merlin_lib.html#is_erl_syntax/1","title":"merlin_lib.is_erl_syntax/1","type":"function"},{"doc":"Calls the given function with the forms inside the given Result , while preserving any errors and/or warnings.","ref":"merlin_lib.html#then/2","title":"merlin_lib.then/2","type":"function"},{"doc":"Updates the given node using the given groups or subtrees of another node. This is a generalisation of erl_syntax:update_tree/2 .","ref":"merlin_lib.html#update_tree/2","title":"merlin_lib.update_tree/2","type":"function"},{"doc":"Returns the value of the given literal node as an Erlang term. Raises {badvalue, Node} if the given Node is not an literal node.","ref":"merlin_lib.html#value/1","title":"merlin_lib.value/1","type":"function"},{"doc":null,"ref":"merlin_lib.html#t:predicate/0","title":"merlin_lib.predicate/0","type":"type"},{"doc":null,"ref":"merlin_lib.html#t:predicate/1","title":"merlin_lib.predicate/1","type":"type"},{"doc":"Helpers for working with forms representing a module. They also work with lists of pretty much any node , but most makes only sense if you have a list of forms representing a module.","ref":"merlin_module.html","title":"merlin_module","type":"module"},{"doc":"Similar to erl_syntax_lib:analyze_forms/1 with some differences noted below. First off it returns maps instead of lists when possible, all fields except module are present. The latter is left alone to make it easy to determine if the module attribute is missing. There's a couple of extra fields, namely file with the value of the first -file attribute or &quot;&quot; , and export_types as an analogue of exports but for -export_type . The attributes are returned as a map from attribute name to a list of attribute nodes, except for spec , type and opaque . These are returned as map from {Function, Arity} to a simplified form of their attribute arguments. Finally, unlike erl_syntax_lib:analyze_forms/1 , this guarantees that most lists are sorted and contain no duplicates. This is accomplished by turning them into ordsets . See also: analysis() .","ref":"merlin_module.html#analyze/1","title":"merlin_module.analyze/1","type":"function"},{"doc":"Same as analyze/1 , but also extracts and appends any inline -compile options to the given one.","ref":"merlin_module.html#analyze/2","title":"merlin_module.analyze/2","type":"function"},{"doc":"Equivalent to annotate(ModuleForms, [bindings, file, resolve_calls, resolve_types]) .","ref":"merlin_module.html#annotate/1","title":"merlin_module.annotate/1","type":"function"},{"doc":"Annotate the given module forms according to the given options. It always annotates each function definition with a is_exported annotation . bindings See erl_syntax_lib:annotate_bindings/2 compile The analysis contains a compile key that merges then given compile options with all -compile attributes in ModuleForms . See analyze/2 file Each node is annotated with the current file, as determined by the most recent -file attribute. resolve_calls Resolves local and remote calls according to the -import attributes, if any. For all successfully resolved calls, this sets both a module and is_exported annotation on the application node. resolve_types Marks exported local types with is_exported annotation on user_type_application nodes.","ref":"merlin_module.html#annotate/2","title":"merlin_module.annotate/2","type":"function"},{"doc":"Returns the given Forms with an -export attribute for the given functions. If the -module attribute is present in the given Forms , then the -export is inserted just after the -module . In addition, if the -module attribute form has an analysis annotation, i.e. from annotate/2 , then it is used to avoid re-exporting any functions already exported. Otherwise the -export is prepended to the given forms.","ref":"merlin_module.html#export/2","title":"merlin_module.export/2","type":"function"},{"doc":"Returns the filename for the first -file attribute in Forms , or none if no such attribute is found.","ref":"merlin_module.html#file/1","title":"merlin_module.file/1","type":"function"},{"doc":"Returns the path to the source for the given module, or undefined if it can't be found.","ref":"merlin_module.html#find_source/1","title":"merlin_module.find_source/1","type":"function"},{"doc":"Returns the line number for the first -file attribute in Forms , or none if no such attribute is found.","ref":"merlin_module.html#line/1","title":"merlin_module.line/1","type":"function"},{"doc":"Returns the module name for the first -module attribute in Forms , or '' if not found.","ref":"merlin_module.html#name/1","title":"merlin_module.name/1","type":"function"},{"doc":null,"ref":"merlin_module.html#t:analysis/0","title":"merlin_module.analysis/0","type":"type"},{"doc":"Represents a function name as returned by erl_syntax_lib:analyze_forms/1 .","ref":"merlin_module.html#t:extended_function_name/0","title":"merlin_module.extended_function_name/0","type":"type"},{"doc":"Represents a list of forms. That is, a list of nodes that represents top level constructs. For example an attribute ( -module ) or a function definition. A good rule of thumb is to think top level stuff that ends with . (period).","ref":"merlin_module.html#t:forms/0","title":"merlin_module.forms/0","type":"type"},{"doc":"Represents a FunctionName/Arity pair.","ref":"merlin_module.html#t:function_name/0","title":"merlin_module.function_name/0","type":"type"},{"doc":"Extends merl to allow patterns with ?Q/1 macro arbitrarily nested, as well as use those patterns directly in function heads. It works by transforming the function clauses to a case , which then merl turns into a call to merl:switch/2 . This allows you to use the power of merl matching much more conveniently. Here's an example, say you have a function func : func ( enter , ? Q ( &quot;_@var&quot; ) , #{ module := State } ) -&gt; success . It becomes something like: func ( Arg1 , Arg2 , Arg3 ) -&gt; case merlin_quote_transform : switch ( [ Arg1 , Arg2 , Arg3 ] , [ fun ( enter , Var1 , #{ module := State } ) -&gt; case Var1 of ? Q ( &quot;_@var&quot; ) -&gt; { ok , success } ; _ -&gt; continue end ( _ , _ , _ ) -&gt; continue end ] ) of { ok , ValueVar1 } -&gt; ValueVar1 ; _ -&gt; error ( function_clause ) end . Which then merl expands to match ?Q(&quot;_@Var&quot;) on `Arg2 / Var1 . Another example: case Foo of # state { form = ? Q ( &quot;_@Var = _@Expr&quot; ) = Form , bindings = Bindings } when erl_syntax : type ( Var ) =:= variable -&gt; erl_eval : expr ( Form , Bindings ) ; # state { form = Form } = State when erl_syntax : type ( Form ) =:= variable -&gt; matches ; # state { } = State -&gt; State end case merlin_quote_transform : switch ( [ Foo ] , [ fun ( # state { form = Form , bindings = Bindings } ) -&gt; case Form of ? Q ( &quot;_@Var = _@Expr&quot; ) when erl_syntax : type ( Var ) =:= variable -&gt; erl_eval : expr ( Form , Bindings ) ; _ -&gt; continue end ; ( _ ) -&gt; continue end , fun ( # state { form = Form } ) -&gt; case try erl_syntax : type ( Form ) =:= variable catch _ : _ -&gt; false end of true -&gt; matches ; false -&gt; continue end ; ( _ ) -&gt; continue end , fun ( # state { } = State ) -&gt; State ; ( _ ) -&gt; continue end ] ) of { ok , _ _ ValueVar1 } -&gt; _ _ ValueVar1 ; _ -&gt; error ( function_clause ) end Here you can see that we allow extended guards even if the clause does not have any merl patterns. But we can't just use it as it, so we wrap it in a try / catch . You might also have noticed that each clause becomes its own fun expression. This is to allow matching in stages, first vanilla Erlang and then merl, while at the same time avoiding unsafe use of variables between clauses. That design took a long time to settle on, but now it works.","ref":"merlin_quote_transform.html","title":"merlin_quote_transform","type":"module"},{"doc":null,"ref":"merlin_quote_transform.html#parse_transform/2","title":"merlin_quote_transform.parse_transform/2","type":"function"},{"doc":"# merlin\n\nParse transform library to make writing those a breeze. It builds on top of\n[merl](https://erlang.org/doc/man/merl.html), and takes inspiration of\n[parse_trans](https://github.com/uwiger/parse_trans/).\n\nThe latter might have support for carrying a state during transform, but it's\nnot documented. The one function that is only supports simple transforms, and\nrequire intimate knowledge about the Erlang AST. While I do think knowing the\nAST is good, `merl` makes it much easier to work with, and it's a shame it\ndoesn't fit into `parse_trans` so well.\n\nMerlin rectifies that by embracing `merl` and provides a small parse\ntransform to extend its `case` matching to function heads.\n\n```erlang\n-include_lib(\"merlin/include/merlin_quote.hrl\").\n\nparse_transform(Forms, CompileOptions) ->\n    {Forms1, _State1} = merlin:transform(Forms, fun transform/3, #{\n        options => CompileOptions\n    }),\n    merlin:return(Forms1).\n\ntransform(enter, ?Q(\"_@Var\"), State) when erl_syntax:type(Var) =:= variable ->\n    ?Q(\"_@Var = 123\");\ntransform(_, _, _) ->\n    continue.\n```\n\nThis example also demonstrate how to use `merlin:transform/3`. The idea is to\nthread the given transformer function through all AST nodes while carrying a\nuser provided state. Depending on the return value, the current node is\neither replaced, kept as is or deleted. In fact, you can return more then one\nnode, which is nigh impossible with a plain transform.\n\nIn all of the above cases, you can also return an updated state. Thus you can\neasily keep track of the current set of variables, or how many times a\ncertain functions is called etc.\n\n`merlin_lib` provide some helpers for common tasks, like finding the\n`-module` attribute, or generating new, unique, variables to avoid accidental\n`badmatch` errors.","ref":"readme.html","title":"merlin","type":"extras"},{"doc":"This uses `rebar3`, and contains a `Makefile` for some common tasks. It also\nuses [logger](https://erlang.org/doc/man/logger.html), with a sample config.\nOnce copied you can tweak it to log what's happening under the hood.\n\n```console\n$ make examples\n```","ref":"readme.html#developing","title":"Developing - merlin","type":"extras"},{"doc":"Apache License\n                           Version 2.0, January 2004\n                        http://www.apache.org/licenses/\n\n   TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION\n\n   1. Definitions.\n\n      \"License\" shall mean the terms and conditions for use, reproduction,\n      and distribution as defined by Sections 1 through 9 of this document.\n\n      \"Licensor\" shall mean the copyright owner or entity authorized by\n      the copyright owner that is granting the License.\n\n      \"Legal Entity\" shall mean the union of the acting entity and all\n      other entities that control, are controlled by, or are under common\n      control with that entity. For the purposes of this definition,\n      \"control\" means (i) the power, direct or indirect, to cause the\n      direction or management of such entity, whether by contract or\n      otherwise, or (ii) ownership of fifty percent (50%) or more of the\n      outstanding shares, or (iii) beneficial ownership of such entity.\n\n      \"You\" (or \"Your\") shall mean an individual or Legal Entity\n      exercising permissions granted by this License.\n\n      \"Source\" form shall mean the preferred form for making modifications,\n      including but not limited to software source code, documentation\n      source, and configuration files.\n\n      \"Object\" form shall mean any form resulting from mechanical\n      transformation or translation of a Source form, including but\n      not limited to compiled object code, generated documentation,\n      and conversions to other media types.\n\n      \"Work\" shall mean the work of authorship, whether in Source or\n      Object form, made available under the License, as indicated by a\n      copyright notice that is included in or attached to the work\n      (an example is provided in the Appendix below).\n\n      \"Derivative Works\" shall mean any work, whether in Source or Object\n      form, that is based on (or derived from) the Work and for which the\n      editorial revisions, annotations, elaborations, or other modifications\n      represent, as a whole, an original work of authorship. For the purposes\n      of this License, Derivative Works shall not include works that remain\n      separable from, or merely link (or bind by name) to the interfaces of,\n      the Work and Derivative Works thereof.\n\n      \"Contribution\" shall mean any work of authorship, including\n      the original version of the Work and any modifications or additions\n      to that Work or Derivative Works thereof, that is intentionally\n      submitted to Licensor for inclusion in the Work by the copyright owner\n      or by an individual or Legal Entity authorized to submit on behalf of\n      the copyright owner. For the purposes of this definition, \"submitted\"\n      means any form of electronic, verbal, or written communication sent\n      to the Licensor or its representatives, including but not limited to\n      communication on electronic mailing lists, source code control systems,\n      and issue tracking systems that are managed by, or on behalf of, the\n      Licensor for the purpose of discussing and improving the Work, but\n      excluding communication that is conspicuously marked or otherwise\n      designated in writing by the copyright owner as \"Not a Contribution.\"\n\n      \"Contributor\" shall mean Licensor and any individual or Legal Entity\n      on behalf of whom a Contribution has been received by Licensor and\n      subsequently incorporated within the Work.\n\n   2. Grant of Copyright License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      copyright license to reproduce, prepare Derivative Works of,\n      publicly display, publicly perform, sublicense, and distribute the\n      Work and such Derivative Works in Source or Object form.\n\n   3. Grant of Patent License. Subject to the terms and conditions of\n      this License, each Contributor hereby grants to You a perpetual,\n      worldwide, non-exclusive, no-charge, royalty-free, irrevocable\n      (except as stated in this section) patent license to make, have made,\n      use, offer to sell, sell, import, and otherwise transfer the Work,\n      where such license applies only to those patent claims licensable\n      by such Contributor that are necessarily infringed by their\n      Contribution(s) alone or by combination of their Contribution(s)\n      with the Work to which such Contribution(s) was submitted. If You\n      institute patent litigation against any entity (including a\n      cross-claim or counterclaim in a lawsuit) alleging that the Work\n      or a Contribution incorporated within the Work constitutes direct\n      or contributory patent infringement, then any patent licenses\n      granted to You under this License for that Work shall terminate\n      as of the date such litigation is filed.\n\n   4. Redistribution. You may reproduce and distribute copies of the\n      Work or Derivative Works thereof in any medium, with or without\n      modifications, and in Source or Object form, provided that You\n      meet the following conditions:\n\n      (a) You must give any other recipients of the Work or\n          Derivative Works a copy of this License; and\n\n      (b) You must cause any modified files to carry prominent notices\n          stating that You changed the files; and\n\n      (c) You must retain, in the Source form of any Derivative Works\n          that You distribute, all copyright, patent, trademark, and\n          attribution notices from the Source form of the Work,\n          excluding those notices that do not pertain to any part of\n          the Derivative Works; and\n\n      (d) If the Work includes a \"NOTICE\" text file as part of its\n          distribution, then any Derivative Works that You distribute must\n          include a readable copy of the attribution notices contained\n          within such NOTICE file, excluding those notices that do not\n          pertain to any part of the Derivative Works, in at least one\n          of the following places: within a NOTICE text file distributed\n          as part of the Derivative Works; within the Source form or\n          documentation, if provided along with the Derivative Works; or,\n          within a display generated by the Derivative Works, if and\n          wherever such third-party notices normally appear. The contents\n          of the NOTICE file are for informational purposes only and\n          do not modify the License. You may add Your own attribution\n          notices within Derivative Works that You distribute, alongside\n          or as an addendum to the NOTICE text from the Work, provided\n          that such additional attribution notices cannot be construed\n          as modifying the License.\n\n      You may add Your own copyright statement to Your modifications and\n      may provide additional or different license terms and conditions\n      for use, reproduction, or distribution of Your modifications, or\n      for any such Derivative Works as a whole, provided Your use,\n      reproduction, and distribution of the Work otherwise complies with\n      the conditions stated in this License.\n\n   5. Submission of Contributions. Unless You explicitly state otherwise,\n      any Contribution intentionally submitted for inclusion in the Work\n      by You to the Licensor shall be under the terms and conditions of\n      this License, without any additional terms or conditions.\n      Notwithstanding the above, nothing herein shall supersede or modify\n      the terms of any separate license agreement you may have executed\n      with Licensor regarding such Contributions.\n\n   6. Trademarks. This License does not grant permission to use the trade\n      names, trademarks, service marks, or product names of the Licensor,\n      except as required for reasonable and customary use in describing the\n      origin of the Work and reproducing the content of the NOTICE file.\n\n   7. Disclaimer of Warranty. Unless required by applicable law or\n      agreed to in writing, Licensor provides the Work (and each\n      Contributor provides its Contributions) on an \"AS IS\" BASIS,\n      WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or\n      implied, including, without limitation, any warranties or conditions\n      of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A\n      PARTICULAR PURPOSE. You are solely responsible for determining the\n      appropriateness of using or redistributing the Work and assume any\n      risks associated with Your exercise of permissions under this License.\n\n   8. Limitation of Liability. In no event and under no legal theory,\n      whether in tort (including negligence), contract, or otherwise,\n      unless required by applicable law (such as deliberate and grossly\n      negligent acts) or agreed to in writing, shall any Contributor be\n      liable to You for damages, including any direct, indirect, special,\n      incidental, or consequential damages of any character arising as a\n      result of this License or out of the use or inability to use the\n      Work (including but not limited to damages for loss of goodwill,\n      work stoppage, computer failure or malfunction, or any and all\n      other commercial damages or losses), even if such Contributor\n      has been advised of the possibility of such damages.\n\n   9. Accepting Warranty or Additional Liability. While redistributing\n      the Work or Derivative Works thereof, You may choose to offer,\n      and charge a fee for, acceptance of support, warranty, indemnity,\n      or other liability obligations and/or rights consistent with this\n      License. However, in accepting such obligations, You may act only\n      on Your own behalf and on Your sole responsibility, not on behalf\n      of any other Contributor, and only if You agree to indemnify,\n      defend, and hold each Contributor harmless for any liability\n      incurred by, or claims asserted against, such Contributor by reason\n      of your accepting any such warranty or additional liability.\n\n   END OF TERMS AND CONDITIONS\n\n   Copyright 2020, Max Nordlund gmail  .\n\n   Licensed under the Apache License, Version 2.0 (the \"License\");\n   you may not use this file except in compliance with the License.\n   You may obtain a copy of the License at\n\n       http://www.apache.org/licenses/LICENSE-2.0\n\n   Unless required by applicable law or agreed to in writing, software\n   distributed under the License is distributed on an \"AS IS\" BASIS,\n   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n   See the License for the specific language governing permissions and\n   limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]}